ScriptName BCTH_FirelightFlickerScript extends ObjectReference
{Script to manage native flickering lights on Object References

=============================================================================
 BCTH_FirelightFlickerScript
 Burning Campfires That Hurt
 by steve40
 v1.0
=============================================================================
 Native flickering lights won't flicker at all unless the light is placed
 directly as a Light REF. Unfortunately, the flicker effect breaks after
 loading a saved game during play, so we also need to detect when the user loads
 a save game so we can reset the light:- disable/enable does the trick.
=============================================================================}

Light Property BCTH_fxCampfireLight512_300 auto mandatory	; set on the form itself
Light Property myLight2 auto					; placeholder only - not used

Hazard Property BCTH_FireHazardStrong100 auto mandatory

ObjectReference LightREF1			; the placed Light REF
ObjectReference HazardREF			; the placed hazard REF

bool Locked = false				; locks the ResetFlicker() function

string sLightNode = "AddOnNode300"	; the AddOnNode in the mesh where we will attach the light. Leave the node index as a -ve number in the mesh.

;=============================================================================

Event OnInit()

	If (BCTH_fxCampfireLight512_300 == None) || (BCTH_FireHazardStrong100 == None)
		GotoState("Vanilla")
		RETURN	; abort
	EndIf

EndEvent



Event OnLoad()

	If BCTH_fxCampfireLight512_300 && BCTH_FireHazardStrong100
		If LightREF1 == none
			LightREF1 = Self.PlaceAtMe(BCTH_fxCampfireLight512_300, 1, True, True, False)
		
			If LightREF1 == None
				GotoState("Vanilla")
				RETURN	; abort
			ElseIf Self.HasNode(sLightNode)
				LightREF1.MoveToNode(Self as ObjectReference, sLightNode, "")
			EndIf
		EndIf

		If HazardREF == none
			HazardREF = Self.PlaceAtMe(BCTH_FireHazardStrong100, 1, True, False, False)
		
			If HazardREF == None
				GotoState("Vanilla")
				RETURN	; abort
			ElseIf Self.HasNode(sLightNode)
				HazardREF.MoveToNode(Self as ObjectReference, sLightNode, "")
			EndIf
		EndIf

		Self.RegisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")	; I love this new function :)
		ResetFlicker()
		RETURN	; we're done for now
	EndIf

	; Failsafe: we shouldn't arrive here unless something went drastically wrong.
	GotoState("Vanilla")
	RETURN	; abort

EndEvent



Event OnUnload()

	Self.UnregisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")

EndEvent


Event OnActivate(ObjectReference akActionRef)
{Not required}
EndEvent



Event Actor.OnPlayerLoadGame(Actor akSender)
{I love it!!!}

	ResetFlicker()
	
EndEvent



Event OnEndState(string asOldState)
{Clean up...}

	Self.UnregisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")

	If LightREF1 != none
		LightREF1.Delete()
	EndIf

	If HazardREF != none
		HazardREF.Delete()
	EndIf

EndEvent

;=============================================================================

Function  ResetFlicker()
{Reset the light and shadow flicker after a save/load}

	If !Locked
		Locked = True

		If (LightREF1 == None) || (Self as ObjectReference == None)	; handle possible situation where console was used to markfordelete this object
			GotoState("Vanilla")
		ElseIf (Self as ObjectReference).IsDisabled()			; handle possible situation where console was used to disable this object
			GotoState("Vanilla")
		Else
			Self.UnregisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")
			Utility.Wait(0.3)					; this small pause fixes an issue where the firelight disappears after fast travelling
			LightREF1.Disable(False)
			LightREF1.Enable(False)
			Self.RegisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")
			Locked = False
		EndIf
	EndIf

EndFunction

;=============================================================================
STATE VANILLA
;=============================================================================

Event OnActivate(ObjectReference akActionRef)
{Do nothing}
EndEvent

;=============================================================================
ENDSTATE
;=============================================================================
